diff --git a/src/base/init/config.c b/src/base/init/config.c
index 932781bcb..4d5fc8ae3 100644
--- a/src/base/init/config.c
+++ b/src/base/init/config.c
@@ -745,8 +745,11 @@ static void read_cpu_info(void)
 {
     char *cpuflags, *cpu;
     int k = 3;
+    int err;
 
-    open_proc_scan("/proc/cpuinfo");
+    err = open_proc_scan("/proc/cpuinfo");
+    if (err)
+      return;
     cpu = get_proc_string_by_key("cpu family");
     if (cpu) {
       k = atoi(cpu);
diff --git a/src/base/misc/utilities.c b/src/base/misc/utilities.c
index 9064c78d0..fe5315391 100644
--- a/src/base/misc/utilities.c
+++ b/src/base/misc/utilities.c
@@ -365,14 +365,14 @@ void close_proc_scan(void)
   procfile_name = procbuf = procbufptr = proclastpos = 0;
 }
 
-void open_proc_scan(const char *name)
+int open_proc_scan(const char *name)
 {
   int size, fd;
   close_proc_scan();
   fd = open(name, O_RDONLY);
   if (fd == -1) {
     error("cannot open %s\n", name);
-    leavedos(5);
+    return -1;
   }
   procfile_name = strdup(name);
   procbuf = malloc(PROCBUFSIZE);
@@ -380,6 +380,7 @@ void open_proc_scan(const char *name)
   procbuf[size] = 0;
   procbufptr = procbuf;
   close(fd);
+  return 0;
 }
 
 void advance_proc_bufferptr(void)
diff --git a/src/dosext/net/ipxglt.c b/src/dosext/net/ipxglt.c
index c4b16a447..5218706a6 100644
--- a/src/dosext/net/ipxglt.c
+++ b/src/dosext/net/ipxglt.c
@@ -84,6 +84,8 @@ static int CheckRouteExist(unsigned long targetNet
 #if !TRUST_RTABLE
 	char buf_net[9], buf_node[13];
 #endif
+	int err;
+
 	sprintf(buf_targ, "%08lX", (unsigned long)htonl(targetNet));
 #if !TRUST_RTABLE
 	sprintf(buf_net, "%08lX", (unsigned long)htonl(network));
@@ -92,11 +94,13 @@ static int CheckRouteExist(unsigned long targetNet
 #endif
 
 	if(access("/proc/net/ipx/route",R_OK) == 0)
-		open_proc_scan("/proc/net/ipx/route");
+		err = open_proc_scan("/proc/net/ipx/route");
 	else if(access("/proc/net/ipx_route",R_OK) == 0)
-		open_proc_scan("/proc/net/ipx_route");
+		err = open_proc_scan("/proc/net/ipx_route");
 	else
 		return 0;
+	if (err)
+		return 0;
 	proc_str = get_proc_string_by_key(buf_targ);
 
 	if (!proc_str) {
diff --git a/src/include/utilities.h b/src/include/utilities.h
index 9cdcbada4..609b13cd9 100644
--- a/src/include/utilities.h
+++ b/src/include/utilities.h
@@ -14,7 +14,7 @@ void sigalarm_onoff(int on);
 char *strprintable(char *s);
 char *chrprintable(char c);
 int is_printable(const char *s);
-void open_proc_scan(const char *name);
+int open_proc_scan(const char *name);
 void close_proc_scan(void);
 char *get_proc_string_by_key(const char *key);
 void advance_proc_bufferptr(void);
